/// <reference types="jest" />
import type { ProviderRpcError, RequestArguments } from '@web3-react/types';
import { EventEmitter } from 'eventemitter3';
export declare class MockEIP1193Provider<T = string> extends EventEmitter {
    chainId?: T;
    accounts?: string[];
    eth_chainId: jest.Mock<T | undefined, [chainId?: T | undefined]>;
    eth_accounts: jest.Mock<string[] | undefined, [accounts?: string[] | undefined]>;
    eth_requestAccounts: jest.Mock<string[] | undefined, [accounts?: string[] | undefined]>;
    request(x: RequestArguments): Promise<unknown>;
    emitConnect(chainId: string): void;
    emitDisconnect(error: ProviderRpcError): void;
    emitChainChanged(chainId: string): void;
    emitAccountsChanged(accounts: string[]): void;
}
